;=========================================================================
; SysMonthCal32 common control demo, modal dialog as main.
;=========================================================================

include \GeneSys\include\GeneSysRt.inc
include \GeneSys\macros\macros.asm
include xmacros.asm
include imdialog.asm
include support.asm

;=========================================================================
.data
.code
;=========================================================================

DialogProc proc hwndDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    SWITCH uMsg

      CASE WM_COMMAND

        .IF loword(wParam) == IDCANCEL

          invoke EndDialog, hwndDlg, NULL

        .ENDIF

      CASE WM_CLOSE

        invoke EndDialog, hwndDlg, NULL

    ENDSW

    xor eax, eax
    ret

DialogProc endp

;=========================================================================
start:
;=========================================================================

    invoke InitializeCommonControls

    invoke DefineDialog, chr$("Today"),
                         WS_OVERLAPPED or \
                         WS_SYSMENU or DS_CENTER,
                         0, 0, 120, 110,
                         0, 0,
                         1

    invoke DefineControl, chr$("SysMonthCal32"), 0,
                          WS_CHILD or WS_VISIBLE,
                          0, 0, 118, 100,
                          0, 101

    invoke CreateModalDialog, 0, ADDR DialogProc, 0

    invoke ExitProcess, 0

;=========================================================================

end start
