;=========================================================================
; Nested modal dialog demo, modal dialog as main.
;=========================================================================

include \GeneSys\include\GeneSysRt.inc
include \GeneSys\macros\macros.asm
include xmacros.asm
include imdialog.asm
include support.asm

IDC_BTNGO equ 101

;=========================================================================
.data
.code
;=========================================================================

NestedDialogProc proc hwndDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    SWITCH uMsg

      CASE WM_COMMAND

        SWITCH loword(wParam)

          CASE IDCANCEL

            invoke EndDialog, hwndDlg, NULL

        ENDSW

      CASE WM_CLOSE

        invoke EndDialog, hwndDlg, NULL

    ENDSW

    xor eax, eax
    ret

NestedDialogProc endp

;=========================================================================

MainDialogProc proc hwndDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    SWITCH uMsg

      CASE WM_COMMAND

        SWITCH loword(wParam)

          CASE IDC_BTNGO

            invoke DefineDialog, chr$("Nested Dialog"),
                                 WS_OVERLAPPED or WS_SYSMENU \
                                 or DS_CENTER,
                                 0, 0, 110, 90,
                                 0, 0,
                                 1

            invoke DefineDefPushButton, chr$("Close"), 0, 35, 50, 40, 12, IDCANCEL

            invoke CreateModalDialog, hwndDlg, ADDR NestedDialogProc, 0

          CASE IDCANCEL

            invoke EndDialog, hwndDlg, NULL

        ENDSW

      CASE WM_CLOSE

        invoke EndDialog, hwndDlg, NULL

    ENDSW

    xor eax, eax
    ret

MainDialogProc endp

;=========================================================================
start:
;=========================================================================

    invoke DefineDialog, chr$("Main Dialog"),
                         WS_OVERLAPPED or WS_SYSMENU \
                         or DS_CENTER,
                         0, 0, 150, 100,
                         0, 0,
                         2

    invoke DefineDefPushButton, chr$("Go"), 0, 30, 60, 40, 12, IDC_BTNGO

    invoke DefinePushButton, chr$("Close"), 0, 80, 60, 40, 12, IDCANCEL

    invoke CreateModalDialog, 0, ADDR MainDialogProc, 0

    invoke ExitProcess, 0

;=========================================================================

end start
